'**********************************************
'* Spin code generated by cspin version 0.066 *
'**********************************************

CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

OBJ
  c : "clibsd"
  strsub : "strsubs"
  cfg : "config"

DAT
  maxstackaddr long 0

PUB start(argc, argv)
  maxstackaddr := @result + 48
  result := ($78f0 - maxstackaddr) / 4
  cfg.config(argc, argv)
  c.start1(31, 30, %10000, 115_200, result)
  'c.printf1(string("Starting stack address = %4.4x\n"), maxstackaddr)
  c.printf1(string("Selecting stack size of %d longs\n"), result)
  strsub.start
  main(argc, argv)
  c.exit(0)

' *********************************************************************
' Include files
' *********************************************************************

CON
  fProcessValue = 0
  fProcessClkfreq = 1
  fProcessAccess = 2
  fProcessRepeat = 3
  fProcessKey = 4
  fProcessCase = 5
  fProcessIf = 6
  fProcessElseIf = 7
  fProcessElse = 8
  fProcessQuit = 9
  fProcessNext = 10
  fProcessReturn = 11
  fProcessBinaryOp = 12
  fProcessBinaryEqOp = 13
  fProcessOp = 14
  fProcessUnaryOp = 15
  fProcessAt = 16
  fProcessExtraOp = 17
  fProcessLeftParen = 18
  fProcessRightBracket = 19
  fProcessPub = 20
  fProcessIntrinsic = 21
  fProcessCallObj = 22
  fCatchObject = 23

Pub ErrorExit
  c.printf2(string("%d: %s\n"), linenum, @buffer)
  c.exit(1)

PUB ExecuteFunction(fFunction, i, num, tokens, state) | retval
  'c.printf6(string("ExecuteFunction(%d, %d, %d, %s, %d, %4.4x)\n"), fFunction, i, num, long[tokens][i], state, @retval)
  if @retval > maxstackaddr
    maxstackaddr := @retval
    if maxstackaddr > $767a
      c.printf0(string("Out of stack space\n"))
      ErrorExit

  case(fFunction)
    fProcessValue :
      retval := ProcessValue(i, num, tokens, state)
    fProcessClkfreq :
      retval := ProcessClkfreq(i, num, tokens, state)
    fProcessAccess :
      retval := ProcessAccess(i, num, tokens, state)
    fProcessRepeat :
      retval := ProcessRepeat(i, num, tokens, state)
    fProcessKey :
      retval := ProcessKey(i, num, tokens, state)
    fProcessCase :
      retval := ProcessCase(i, num, tokens, state)
    fProcessIf :
      retval := ProcessIf(i, num, tokens, state)
    fProcessElseIf :
      retval := ProcessElseIf(i, num, tokens, state)
    fProcessElse :
      retval := ProcessElse(i, num, tokens, state)
    fProcessQuit :
      retval := ProcessQuit(i, num, tokens, state)
    fProcessNext :
      retval := ProcessNext(i, num, tokens, state)
    fProcessReturn :
      retval := ProcessReturn(i, num, tokens, state)
    fProcessBinaryOp :
      retval := ProcessBinaryOp(i, num, tokens, state)
    fProcessBinaryEqOp :
      retval := ProcessBinaryEqOp(i, num, tokens, state)
    fProcessOp :
      retval := ProcessOp(i, num, tokens, state)
    fProcessUnaryOp :
      retval := ProcessUnaryOp(i, num, tokens, state)
    fProcessAt :
      retval := ProcessAt(i, num, tokens, state)
    fProcessExtraOp :
      retval := ProcessExtraOp(i, num, tokens, state)
    fProcessLeftParen :
      retval := ProcessLeftParen(i, num, tokens, state)
    fProcessRightBracket :
      retval := ProcessRightBracket(i, num, tokens, state)
    fProcessPub :
      retval := ProcessPub(i, num, tokens, state)
    fProcessIntrinsic :
      retval := ProcessIntrinsic(i, num, tokens, state)
    fProcessCallObj :
      retval := ProcessCallObj(i, num, tokens, state)
    fCatchObject :
      retval := CatchObject(i, num, tokens, state)
    OTHER :
      c.printf1(string("ProcessFunction: Invalid function number - %d\n"), fFunction)
      ErrorExit
  return retval
' *********************************************************************
' Defines
' *********************************************************************
' Symbol Types

CON
  TYPE_PUB = 1
  TYPE_DAT = 2
  TYPE_LOCAL = 3
  TYPE_CON = 4
  TYPE_KEY = 5
  TYPE_OP = $100
  TYPE_NUM = 7
  TYPE_ACCESS = 8
  TYPE_VAR = 9
  TYPE_REG = 10
  TYPE_POSTOP = $200
  TYPE_OBJECT = 11
' Expected type for next symbol - i.e., value or operator
  EXPECT_VAL = 0
  EXPECT_OP = 1
' Actions that are performed on a value
  ACTION_NONE = 0
  ACTION_LOAD = 1
  ACTION_STORE = 2
  ACTION_ADDR = 3
  ACTION_EXEC = 4
' Types of Spin blocks
  LOOP_PUB = 1
  LOOP_REPEAT = 2
  LOOP_IF = 3
  LOOP_ELSE = 4
  LOOP_ELSEIF = 5
  LOOP_CASE = 6
  LOOP_CASE1 = 7
' Size of the symbol table and string pool
  MAX_LEVELS = 5
  MAX_SYMBOLS = 250
  STRING_POOL_SIZE = MAX_SYMBOLS * 8
' Special Characters
  DOUBLE_QUOTE = $22
  SINGLE_QUOTE = $27
  TAB_CHAR = 9
' Debug print flag
'#undef PRINT_PROCESS
' *********************************************************************
' Typedefs
' *********************************************************************
' Function pointer used by a symbol
' Symbol struct
' typedef struct SymbolS
name = 0
type = 2
func = 4
parm = 6
size = 8
' *********************************************************************
' Function prototypes
' *********************************************************************
' *********************************************************************
' Global variables
' *********************************************************************
' Input line buffer and token buffers

VAR
  byte buffer[100]
  byte buf2[200]
  long tokens_0[50]
  long commentflag
  long linenum
' Variables used for each block level
' PUBs and PRIs start at level zero

DAT
  indent2 long 0
  level long 0

VAR
  long indent[MAX_LEVELS]
  long labelstart[MAX_LEVELS]
  long labelend[MAX_LEVELS]
  long looplevel[MAX_LEVELS]
  long looptype[MAX_LEVELS]
' This variable is used to generate unique labels

DAT
  labelnum long 1
' Symbol table and string storage buffer
  symnum long 0
  pubnum long 0

VAR
  long symnum_save

DAT
  strindex long 0

VAR
  long symtable[10*MAX_SYMBOLS/4]
  byte strpool[STRING_POOL_SIZE]

DAT
  nullstr byte 0
' Keyword lists
  AccessChar byte "b", "w", "l"
  datstr byte "coginit", 0, "cognew", 0, "lockset", 0
  byte "lockclr", 0
  ret_list long @datstr + 16, @datstr + 24, @datstr + 31
  long @datstr + 39, 0
  datstr_0 byte "pub", 0, "pri", 0, "dat", 0, "con", 0
  byte "var", 0, "obj", 0
  section_keyword long @datstr_0 + 16, @datstr_0 + 20, @datstr_0 + 24
  long @datstr_0 + 28, @datstr_0 + 32, @datstr_0 + 36, 0
  datstr_1 byte "else", 0, "elseif", 0, "elseifnot", 0
  elselist long @datstr_1 + 16, @datstr_1 + 21, @datstr_1 + 28
  long 0
  datstr_2 byte "byte", 0, "word", 0, "long", 0
  type_keyword long @datstr_2 + 16, @datstr_2 + 21, @datstr_2 + 26
  long 0
' Input and output files

VAR
  long infile
  long outfile
' *********************************************************************
' This program compiles a Spin file to a Spasm file.  It appends
' a ".spin" extension to the specified file name and opens it for
' input.  It appends a ".spasm" extension for the output file name.
' Note: Currently writing the Spasm code to the standard output
' The compiler uses two passes though the source code.  The first
' pass is used to gather all the global symbols, which include the
' method names, constants, DAT variables and VAR variables.
' During the second pass, the local variables are extracted for each
' method, and the Spasm code is generated.
' *********************************************************************

PUB main(argc, argv)
  if (argc <> 2)
    usage
  ' Initialize the symbol table with the Spin keywords
  AddKeywords
  ' Open the input file
  c.strcpy(@buffer, long[argv][1])
  result := strsub.FindChar(@buffer, ".")
  ifnot byte[result]
    c.strcpy(result, string(".spn"))
  infile := c.fopen(@buffer, string("r"))
  if (not infile)
    usage
  'c.printf2(string("infile = %4.4x, outfile = %4.4x\n"), infile, outfile)
  'c.printf1(string("symnum = %d after AddKeywords\n"), symnum)
  ' Perform the first pass and get all the global symbols
  GetGlobalSymbols
  'c.printf1(string("symnum = %d after GetGlobalSymbols\n"), symnum)
  ' Rewind the file and perform the second pass
  c.fseek(infile, 0, c#SEEK_SET)

  ' Open the output file
  c.strcpy(@buffer, long[argv][1])
  result := strsub.FindChar(@buffer, ".")
  c.strcpy(result, string(".spa"))
  outfile := c.fopen(@buffer, string("w"))
  if (not outfile)
    usage

  GenerateSpasm
  'c.printf1(string("symnum = %d after GenerateSpasm\n"), symnum)
  c.printf1(string("maxstackaddr = %4.4x\n"), maxstackaddr)
  c.CheckStackSpace
  c.fclose(infile)
  c.fclose(outfile)
' *********************************************************************
' Print the usage information and exit
' *********************************************************************

PUB usage
  c.printf0(string("usage: spinit file\n"))
  c.exit(1)
' *********************************************************************
' This routine allocates a string buffer from the buffer pool
' *********************************************************************

PUB StrAlloc(size_0) | ptr
  ptr := @strpool[strindex]
  if (strindex + size_0 > STRING_POOL_SIZE)
    c.printf0(string("String pool is out of space\n"))
    c.exit(1)
  strindex += size_0
  return ptr
' *********************************************************************
' This routine adds a symbol to the symbol table
' *********************************************************************

PUB AddSymbol(str, type_0, func_0, parm_0) | symptr
  symptr := StrAlloc(strsize(str) + 1)
  if (symnum => MAX_SYMBOLS)
    c.printf0(string("Symbol table is full\n"))
    c.exit(1)
  'c.printf2(string("AddSymbol: %s, %d\n"), str, type)
  word[@symtable +(10 * symnum) + name] := symptr
  word[@symtable +(10 * symnum) + type] := type_0
  word[@symtable +(10 * symnum) + func] := func_0
  word[@symtable +(10 * symnum) + parm] := parm_0
  word[@symtable +(10 * symnum) + size] := 4
  c.strcpy(symptr, str)
  symnum++
  return symnum - 1
' *********************************************************************
' This routine finds a symbol in the table and returns
' it's index, or -1 if not found.
' *********************************************************************

PUB FindSymbol(str) | i
  i := 0
  repeat while (i < symnum)
    'if (strcmp(str, symtable[i].name) == 0)
    if (strsub.StrCompNoCase(str, word[@symtable +(10 * i) + name]))
      'printf("FindSymbol: found %s\n", str);
      quit
    i++
  if (i == symnum)
    i := - 1
  return i
' *********************************************************************
' This routine adds a symbol to the symbol table if it is not
' already in the table.  If a duplicate exists, and error message
' is printed and the program c.exits.
' *********************************************************************

PUB AddSymbolCheck(str, type_0, func_0, parm_0)
  if (FindSymbol(str) => 0)
    c.printf1(string("Duplicate symbol - %s\n"), str)
    c.exit(1)
  return AddSymbol(str, type_0, func_0, parm_0)
' *********************************************************************
' This routine determines if a token is a number or
' a symbol in the symbol table.  Numbers use symbol
' table entry zero.  If the token is undefined an error
' message is printed, and the program c.exits.
' *********************************************************************

PUB FindSymbolType(str) | j, val
  j := FindSymbol(str)
  if (j < 0)
    val := byte[str][0]
    if (val == "$" or val == DOUBLE_QUOTE or(val => "0" and val =< "9"))
      j := 0
    else
      c.printf1(string("Undefined symbol %s\n"), str)
      c.exit(1)
  return j
' *********************************************************************
' This routine returns the precedence of a symbol if its
' an operator, or zero if not.
' *********************************************************************

PUB GetSymbolPrecedence(str) | precedence, j
  precedence := 0
  j := FindSymbolType(str)
  if (word[@symtable +(10 * j) + type] & TYPE_OP)
    precedence := word[@symtable +(10 * j) + type] & 15
  return precedence
' *********************************************************************
' This routine locates a token in the symbol table and executes
' it's function.  It combines the expected type, precedence and
' action value into a single state variable.
' *********************************************************************

PUB ExecuteSymbol(i, num, tokens, expect, prec, action) | state, j
  state :=(expect << 8) |(prec << 4) | action
  j := FindSymbolType(long[tokens][i])
  'printf("ExecuteSymbol %s %d %d %d %8.8x\n", tokens[i], expect, prec, action, state);
  return ExecuteFunction(word[@symtable +(10 * j) + func], i, num, tokens, state)
' *********************************************************************
' This routine checks if the expected type passed in the state
' variable matches the current token type.
' *********************************************************************

PUB CheckExpect(state, current, str) | expect
  expect := state >> 8
  if (expect <> current)
    c.printf3(string("expect = %d, current = %d, %s\n"), expect, current, str)
    c.exit(1)
' *********************************************************************
' This is a default keyword function that should never be called.
' *********************************************************************

PUB ProcessKey(i, num, tokens, state)
  c.printf0(string("KEY\n"))
  return i + 1
' *********************************************************************
' This routine handles the repeat statement
' *********************************************************************

PUB ProcessRepeat(i, num, tokens, state)
  labelstart[++level] := labelnum
  c.fprintf1(outfile, string("label%4.4d\n"), labelnum++)
  labelend[level] := labelnum
  indent[level] := indent2
  looplevel[level] := level
  looptype[level] := LOOP_REPEAT
  i++
  if (i => num or byte[long[tokens][i]][0] == SINGLE_QUOTE)
    return i
  if (not strsub.StrCompNoCase(long[tokens][i], string("while")))
    c.printf1(string("Expected while or EOL - %s\n"), long[tokens][i])
    c.exit(1)
  if (++i => num)
    c.printf0(string("Encountered EOL\n"))
    ErrorExit
  'i = ExecuteSymbol(i, num, tokens, EXPECT_VAL, 12, ACTION_LOAD);
  i := ProcessExpression(i, num, tokens, 12, ACTION_LOAD)
  c.fprintf1(outfile, string("        jz label%4.4d\n"), labelnum++)
  return i
' *********************************************************************
' This routine handles case statements
' *********************************************************************

PUB ProcessCase(i, num, tokens, state)
  c.fprintf1(outfile, string("        ldl label%4.4d\n"), labelnum)
  labelstart[++level] := 0
  labelend[level] := labelnum++
  labelstart[level] := 0
  indent[level] := indent2
  looplevel[level] := looplevel[level - 1]
  looptype[level] := LOOP_CASE
  i++
  if (i => num)
    c.printf1(string("Expected expression - %s\n"), long[tokens][i])
    ErrorExit
  i := ProcessExpression(i, num, tokens, 12, ACTION_LOAD)
  return i
' *********************************************************************
' This routine handles if and ifnot statements
' *********************************************************************

PUB ProcessIf(i, num, tokens, state) | j, ifnotflag
  ifnotflag := strsub.StrCompNoCase(long[tokens][i], string("ifnot"))
  labelstart[++level] := 0
  labelend[level] := labelnum
  labelstart[level] := 0
  indent[level] := indent2
  looplevel[level] := looplevel[level - 1]
  looptype[level] := LOOP_IF
  i++
  if (i => num or byte[long[tokens][i]][0] == SINGLE_QUOTE)
    c.printf1(string("Expected expression - %s\n"), long[tokens][i])
    ErrorExit
  i := ProcessExpression(i, num, tokens, 12, ACTION_LOAD)
  if (ifnotflag)
    c.fprintf1(outfile, string("        jnz label%4.4d\n"), labelnum++)
  else
    c.fprintf1(outfile, string("        jz label%4.4d\n"), labelnum++)
  return i
' *********************************************************************
' This routine handles elseif and elseifnot statements
' *********************************************************************

PUB ProcessElseIf(i, num, tokens, state) | j, ifnotflag
  ifnotflag := strsub.StrCompNoCase(long[tokens][i], string("elseifnot"))
  if ((looptype[level] <> LOOP_IF and looptype[level] <> LOOP_ELSEIF) or indent[level] <> indent2)
    c.printf1(string("%s statement without an if\n"), long[tokens][0])
    ErrorExit
  if (looptype[level] == LOOP_IF)
    labelstart[level] := labelnum++
  c.fprintf1(outfile, string("        jmp label%4.4d\n"), labelstart[level])
  c.fprintf1(outfile, string("label%4.4d\n"), labelend[level])
  looptype[level] := LOOP_ELSEIF
  labelend[level] := labelnum
  if (++i => num or byte[long[tokens][i]][0] == SINGLE_QUOTE)
    c.printf1(string("Expected expression - %s\n"), long[tokens][i])
    ErrorExit
  i := ProcessExpression(i, num, tokens, 12, ACTION_LOAD)
  if (ifnotflag)
    c.fprintf1(outfile, string("        jnz label%4.4d\n"), labelnum++)
  else
    c.fprintf1(outfile, string("        jz label%4.4d\n"), labelnum++)
  return i
' *********************************************************************
' This routine handles else statements
' *********************************************************************

PUB ProcessElse(i, num, tokens, state)
  if ((looptype[level] <> LOOP_IF and looptype[level] <> LOOP_ELSEIF) or indent[level] <> indent2)
    c.printf1(string("%s statement without an if\n"), long[tokens][0])
    ErrorExit
  if (looptype[level] == LOOP_IF)
    c.fprintf1(outfile, string("        jmp label%4.4d\n"), labelnum)
    c.fprintf1(outfile, string("label%4.4d\n"), labelend[level])
    labelend[level] := labelnum++
  else
    c.fprintf1(outfile, string("        jmp label%4.4d\n"), labelstart[level])
    c.fprintf1(outfile, string("label%4.4d\n"), labelend[level])
    labelend[level] := labelstart[level]
    labelstart[level] := 0
  looptype[level] := LOOP_ELSE
  return i + 1
' *********************************************************************
' This routine handles the quit statement
' *********************************************************************

PUB ProcessQuit(i, num, tokens, state) | j
  j := looplevel[level]
  if (labelend[j])
    c.fprintf1(outfile, string("        jmp label%4.4d\n"), labelend[j])
  return i + 1
' *********************************************************************
' This routine handles the next statement
' *********************************************************************

PUB ProcessNext(i, num, tokens, state) | j
  j := looplevel[level]
  if (labelstart[j])
    c.fprintf1(outfile, string("        jmp label%4.4d\n"), labelstart[j])
  return i + 1
' *********************************************************************
' This routine handles return statements
' *********************************************************************

PUB ProcessReturn(i, num, tokens, state)
  i++
  if (i => num or byte[long[tokens][i]][0] == SINGLE_QUOTE)
    c.fprintf0(outfile, string("        ret\n"))
    return i
  i := ProcessExpression(i, num, tokens, 12, ACTION_LOAD)
  c.fprintf0(outfile, string("        retval\n"))
  return i
' *********************************************************************
' This routine handles the byte[], word[] and long[] operator
' *********************************************************************

PUB ProcessAccess(i, num, tokens, state) | index, action, xstr, postop
  action := state & 15
  xstr := @nullstr
  postop := - 1
  ' Determine the size
  if (strsub.StrCompNoCase(long[tokens][i], string("byte")))
    index := 0
  elseif (strsub.StrCompNoCase(long[tokens][i], string("word")))
    index := 1
  else
    index := 2
  CheckExpect(state, EXPECT_VAL, long[tokens][i])
  if (++i => num)
    c.printf0(string("Encountered EOL\n"))
    ErrorExit
  if (c.strcmp(long[tokens][i], string("[")))
    c.printf1(string("Expected '[' - %s\n"), long[tokens][i])
    ErrorExit
  if (++i => num)
    c.printf0(string("Encountered EOL\n"))
    ErrorExit
  ' Get the value between the brackets
  i := ProcessExpression(i, num, tokens, 12, ACTION_LOAD)
  if (c.strcmp(long[tokens][i], string("]")))
    c.printf1(string("Expected ']' - %s\n"), long[tokens][i])
    ErrorExit
  ' Check for index
  if (++i < num and byte[long[tokens][i]][0] == "[")
    i := ProcessExpression(i + 1, num, tokens, 12, ACTION_LOAD)
    if (c.strcmp(long[tokens][i], string("]")))
      c.printf1(string("Expected ']' - %s\n"), long[tokens][i])
      ErrorExit
    i++
    xstr := string("x")
  ' Check for post operator
  if (i < num)
    postop := FindSymbolType(long[tokens][i])
    if (word[@symtable +(10 * postop) + type] & TYPE_POSTOP)
      action := ACTION_EXEC
    else
      postop := - 1
  ' Peform the memory operation
  if (action == ACTION_LOAD)
    c.fprintf2(outfile, string("        ld%ca%s\n"), AccessChar[index], xstr)
  elseif (action == ACTION_STORE)
    c.fprintf2(outfile, string("        st%ca%s\n"), AccessChar[index], xstr)
  elseif (action == ACTION_ADDR)
    c.fprintf2(outfile, string("        la%ca%s\n"), AccessChar[index], xstr)
  elseif (action == ACTION_EXEC)
    c.fprintf2(outfile, string("        ex%ca%s"), AccessChar[index], xstr)
    if (postop <> - 1)
      i := ExecuteFunction(word[@symtable +(10 * postop) + func], i, num, tokens,(EXPECT_OP << 8) |(state & 255))
  return i
' *********************************************************************
' This routine should never be called
' *********************************************************************

PUB ProcessOp(i, num, tokens, state)
  c.printf0(string("OP\n"))
  return i + 1
' *********************************************************************
' This routine handles the binary operators.  It will return if
' the current operator has greater than or equal precedence than
' the previous opertor.  Otherwise, is will call ProcessExpression
' to recursively process the next part of the expression.
' *********************************************************************

PUB ProcessBinaryOp(i, num, tokens, state) | k, j, prec1, prec2
  j := FindSymbolType(long[tokens][i])
  prec1 :=(state >> 4) & 15
  prec2 := word[@symtable +(10 * j) + type] & 15
  CheckExpect(state, EXPECT_OP, long[tokens][i])
  ' This test is not needed, and it should never be true.
  ' However, I'm keeping it for now for debug purposes.
  if (prec1 =< prec2)
    c.printf0(string("XXXXXXXXXX ProcessBinaryOp XXXXXXXXXX\n"))
    return i
  if (++i => num)
    c.printf0(string("Expected value, found EOL\n"))
    ErrorExit
  i := ProcessExpression(i, num, tokens, prec2, ACTION_LOAD)
  c.fprintf1(outfile, string("        %s\n"), word[@symtable +(10 * j) + parm])
  return i
' *********************************************************************
' This routine handles the binary assignment operators
' *********************************************************************

PUB ProcessBinaryEqOp(i, num, tokens, state) | k, j, prec1, prec2
  j := FindSymbolType(long[tokens][i])
  prec1 :=(state >> 4) & 15
  prec2 := word[@symtable +(10 * j) + type] & 15
  CheckExpect(state, EXPECT_OP, long[tokens][i])
  'if (prec1 <= prec2) return i;
  if (i + 1 => num)
    c.printf0(string("Expected value, found EOL\n"))
    ErrorExit
  'i = ExecuteSymbol(i, num, tokens, EXPECT_VAL, prec2, ACTION_LOAD);
  c.fprintf1(outfile, string(" %s\n"), word[@symtable +(10 * j) + parm])
  return i
' *********************************************************************
' This routine handles the non-assignment unary operators
' *********************************************************************

PUB ProcessUnaryOp(i, num, tokens, state) | j, prec2
  j := FindSymbolType(long[tokens][i])
  prec2 := word[@symtable +(10 * j) + type] & 15
  CheckExpect(state, EXPECT_VAL, long[tokens][i])
  if (++i => num)
    c.printf0(string("Expected value, found EOL\n"))
    ErrorExit
  i := ExecuteSymbol(i, num, tokens, EXPECT_VAL, prec2, ACTION_LOAD)
  c.fprintf1(outfile, string("        %s\n"), word[@symtable +(10 * j) + parm])
  return i
' *********************************************************************
' This routine handles the extra unary assignment operators
' *********************************************************************

PUB ProcessExtraOp(i, num, tokens, state) | j, prec, action, expect, opstr[5], ptr1, ptr2, lstr, len
  j := FindSymbolType(long[tokens][i])
  'int prec2 = symtable[j].type & 15;, prec, action, expect, opstr[5], ptr1, ptr2, lstr
  prec :=(state >> 4) & 15
  action := state & 15
  expect := state >> 8
  ptr1 := word[@symtable +(10 * j) + parm]
  ptr2 := strsub.FindChar(ptr1, "-")
  lstr := @nullstr
  if (action == ACTION_LOAD)
    lstr := string(" load")
  ' Check if it is a pre-op
  if (expect == EXPECT_VAL)
    len := ptr2 - ptr1
    c.memcpy(@opstr, ptr1, len)
    byte[@opstr][len] := 0
  ' Otherwise, it's a post-op
  else
    c.fprintf2(outfile, string(" %s%s\n"), ptr2 + 1, lstr)
    return i + 1
  if (++i => num)
    c.printf0(string("Expected value, found EOL\n"))
    ErrorExit
  i := ExecuteSymbol(i, num, tokens, EXPECT_VAL, prec, ACTION_EXEC)
  c.fprintf2(outfile, string(" %s%s\n"), @opstr, lstr)
  return i
' *********************************************************************
' This routine handles the "@" address operator
' *********************************************************************

PUB ProcessAt(i, num, tokens, state) | j, action
  action := state & 15
  'printf("ProcessAt %d %8.8x\n", action, state);
  if (action <> ACTION_LOAD)
    c.printf1(string("Invalid action for address operator - %d\n"), action)
    ErrorExit
  if (++i => num)
    c.printf0(string("Expected variable - EOL\n"))
    ErrorExit
  j := FindSymbolType(long[tokens][i])
  state :=(state & $ffffff00) | ACTION_ADDR
  i := ExecuteFunction(word[@symtable +(10 * j) + func], i, num, tokens, state)
  return i
' *********************************************************************
' This routine handles intrinsic functions and calling methods
' *********************************************************************

PUB ProcessFunction(i, num, tokens, state, intrinsic) | first, pubname, action, prec
  first := 1
  pubname := long[tokens][i]
  action := state & 15
  prec :=(state >> 4) & 15
  if (intrinsic <> 1)
    if (action == ACTION_LOAD)
      c.fprintf0(outfile, string("        ldfrmr\n"))
    else
      c.fprintf0(outfile, string("        ldfrm\n"))
  if (++i < num and byte[long[tokens][i]][0] == "(")
    i++
    repeat while (i < num and byte[long[tokens][i]][0] <> ")")
      if (first)
        first := 0
      else
        if (c.strcmp(long[tokens][i], string(",")))
          c.printf1(string("Expected ',' or ')' - %s\n"), long[tokens][i])
          ErrorExit
        i++
      i := ProcessExpression(i, num, tokens, 12, ACTION_LOAD)
  if (intrinsic == 1)
    if (action == ACTION_LOAD and strsub.FindListNoCase(pubname, @ret_list) => 0)
      c.fprintf1(outfile, string("        %sret\n"), pubname)
    else
      c.fprintf1(outfile, string("        %s\n"), pubname)
  elseif (intrinsic == 0)
    c.fprintf1(outfile, string("        call %s\n"), pubname)
  else
    c.fprintf1(outfile, string("        callobj %s\n"), pubname)
  if (++i < num)
    i := ExecuteSymbol(i, num, tokens, EXPECT_OP, prec, action)
  return i
' *********************************************************************
' This is used to call methods in external objects
' *********************************************************************

PUB ProcessCallObj(i, num, tokens, state)
  return ProcessFunction(i, num, tokens, state, 3)
' *********************************************************************
' This is used to call local methods
' *********************************************************************

PUB ProcessPub(i, num, tokens, state)
  return ProcessFunction(i, num, tokens, state, 0)
' *********************************************************************
' This handles intrinsic functions
' *********************************************************************

PUB ProcessIntrinsic(i, num, tokens, state)
  return ProcessFunction(i, num, tokens, state, 1)
' *********************************************************************
' This handles tokens that are variables, numbers or constants
' *********************************************************************

PUB ProcessValue(i, num, tokens, state) | j, xstr, vstr, sstr, action, action1, prec, postop
  xstr := @nullstr
  vstr := long[tokens][i]
  action := state & 15
  action1 := action
  prec :=(state >> 4) & 15
  postop := - 1
  ' Determine the variable size
  j := FindSymbolType(long[tokens][i])
  if (word[@symtable +(10 * j) + type] == TYPE_REG)
    sstr := string("reg")
  elseif (word[@symtable +(10 * j) + size] == 1)
    sstr := string("b")
  elseif (word[@symtable +(10 * j) + size] == 2)
    sstr := string("w")
  else
    sstr := string("l")
  'printf("ProcessValue %s\n", tokens[i]);
  CheckExpect(state, EXPECT_VAL, long[tokens][i])
  ' Check for index
  if (++i < num and byte[long[tokens][i]][0] == "[")
    i := ProcessExpression(i + 1, num, tokens, 12, ACTION_LOAD)
    if (c.strcmp(long[tokens][i], string("]")))
      c.printf1(string("Expected ']' - %s\n"), long[tokens][i])
      ErrorExit
    i++
    xstr := string("x")
  ' Check for post operator
  if (i < num)
    postop := FindSymbolType(long[tokens][i])
    if (word[@symtable +(10 * postop) + type] & TYPE_POSTOP)
      action := ACTION_EXEC
    else
      postop := - 1
  ' Perform action
  if (action == ACTION_LOAD)
    c.fprintf3(outfile, string("        ld%s%s %s\n"), sstr, xstr, vstr)
  elseif (action == ACTION_STORE)
    c.fprintf3(outfile, string("        st%s%s %s\n"), sstr, xstr, vstr)
  elseif (action == ACTION_ADDR)
    c.fprintf3(outfile, string("        la%s%s %s\n"), sstr, xstr, vstr)
  elseif (action == ACTION_EXEC)
    c.fprintf3(outfile, string("        ex%s%s %s"), sstr, xstr, vstr)
    if (postop <> - 1)
      i := ExecuteFunction(word[@symtable +(10 * postop) + func], i, num, tokens,(EXPECT_OP << 8) |(prec << 4) | action1)
  return i
' *********************************************************************
' This handles the right parenthesis and bracket and the comma
' *********************************************************************

PUB ProcessRightBracket(i, num, tokens, state)
  CheckExpect(state, EXPECT_OP, long[tokens][i])
  return i
' *********************************************************************
' This handles the clkfreq variable
' *********************************************************************

PUB ProcessClkfreq(i, num, tokens, state) | action
  action := state & 15
  c.fprintf0(outfile, string("        ldli0\n"))
  if (action == ACTION_LOAD)
    c.fprintf0(outfile, string("        ldla\n"))
  elseif (action == ACTION_STORE)
    c.fprintf0(outfile, string("        stla\n"))
  return i + 1
' *********************************************************************
' This routine initializes the symbol table with
' the standard Spin tokens.
' *********************************************************************

{
PUB AddKeywords
  ' Entry zero is used for numbers
  AddSymbol(@nullstr, TYPE_NUM, fProcessValue, 0)
  ' Spin keywords
  AddSymbol(string("result"), TYPE_LOCAL, fProcessValue, 0)
  AddSymbol(string("clkfreq"), 0, fProcessClkfreq, 0)
  AddSymbol(string("byte"), TYPE_ACCESS, fProcessAccess, 0)
  AddSymbol(string("word"), TYPE_ACCESS, fProcessAccess, 0)
  AddSymbol(string("long"), TYPE_ACCESS, fProcessAccess, 0)
  AddSymbol(string("repeat"), TYPE_KEY, fProcessRepeat, 0)
  AddSymbol(string("while"), TYPE_KEY, fProcessKey, 0)
  AddSymbol(string("case"), TYPE_KEY, fProcessCase, 0)
  AddSymbol(string("if"), TYPE_KEY, fProcessIf, 0)
  AddSymbol(string("ifnot"), TYPE_KEY, fProcessIf, 0)
  AddSymbol(string("elseif"), TYPE_KEY, fProcessElseIf, 0)
  AddSymbol(string("elseifnot"), TYPE_KEY, fProcessElseIf, 0)
  AddSymbol(string("else"), TYPE_KEY, fProcessElse, 0)
  AddSymbol(string("quit"), TYPE_KEY, fProcessQuit, 0)
  AddSymbol(string("next"), TYPE_KEY, fProcessNext, 0)
  AddSymbol(string("return"), TYPE_KEY, fProcessReturn, 0)
  ' Binary Operators - The 4 LSBs of the type is the precedence
  AddSymbol(string("-"), TYPE_OP + 6, fProcessBinaryOp, string("sub"))
  AddSymbol(string("+"), TYPE_OP + 6, fProcessBinaryOp, string("add"))
  AddSymbol(string("/"), TYPE_OP + 5, fProcessBinaryOp, string("div"))
  AddSymbol(string("*"), TYPE_OP + 5, fProcessBinaryOp, string("mul"))
  AddSymbol(string("**"), TYPE_OP + 5, fProcessBinaryOp, string("mulh"))
  AddSymbol(string("//"), TYPE_OP + 5, fProcessBinaryOp, string("mod"))
  AddSymbol(string("#>"), TYPE_OP + 7, fProcessBinaryOp, string("minlim"))
  AddSymbol(string("<#"), TYPE_OP + 7, fProcessBinaryOp, string("maxlim"))
  AddSymbol(string("~>"), TYPE_OP + 2, fProcessBinaryOp, string("sar"))
  AddSymbol(string("<<"), TYPE_OP + 2, fProcessBinaryOp, string("shl"))
  AddSymbol(string(">>"), TYPE_OP + 2, fProcessBinaryOp, string("shr"))
  AddSymbol(string("->"), TYPE_OP + 2, fProcessBinaryOp, string("ror"))
  AddSymbol(string("<-"), TYPE_OP + 2, fProcessBinaryOp, string("rol"))
  AddSymbol(string("><"), TYPE_OP + 2, fProcessBinaryOp, string("rev"))
  AddSymbol(string("&"), TYPE_OP + 3, fProcessBinaryOp, string("and"))
  AddSymbol(string("|"), TYPE_OP + 4, fProcessBinaryOp, string("or"))
  AddSymbol(string("^"), TYPE_OP + 4, fProcessBinaryOp, string("xor"))
  AddSymbol(string("and"), TYPE_OP + 10, fProcessBinaryOp, string("andl"))
  AddSymbol(string("or"), TYPE_OP + 11, fProcessBinaryOp, string("orl"))
  AddSymbol(string("=="), TYPE_OP + 8, fProcessBinaryOp, string("cmpeq"))
  AddSymbol(string("<>"), TYPE_OP + 8, fProcessBinaryOp, string("cmpne"))
  AddSymbol(string("<"), TYPE_OP + 8, fProcessBinaryOp, string("cmplt"))
  AddSymbol(string(">"), TYPE_OP + 8, fProcessBinaryOp, string("cmpgt"))
  AddSymbol(string("=<"), TYPE_OP + 8, fProcessBinaryOp, string("cmple"))
  AddSymbol(string("=>"), TYPE_OP + 8, fProcessBinaryOp, string("cmpge"))
  ' BinaryEqual Operators
  AddSymbol(string("-="), TYPE_POSTOP + 6, fProcessBinaryEqOp, string("sub"))
  AddSymbol(string("+="), TYPE_POSTOP + 6, fProcessBinaryEqOp, string("add"))
  AddSymbol(string("/="), TYPE_POSTOP + 5, fProcessBinaryEqOp, string("div"))
  AddSymbol(string("*="), TYPE_POSTOP + 5, fProcessBinaryEqOp, string("mul"))
  AddSymbol(string("**="), TYPE_POSTOP + 5, fProcessBinaryEqOp, string("mulh"))
  AddSymbol(string("//="), TYPE_POSTOP + 5, fProcessBinaryEqOp, string("mod"))
  AddSymbol(string("#>="), TYPE_POSTOP + 7, fProcessBinaryEqOp, string("minlim"))
  AddSymbol(string("<#="), TYPE_POSTOP + 7, fProcessBinaryEqOp, string("maxlim"))
  AddSymbol(string("~>="), TYPE_POSTOP + 2, fProcessBinaryEqOp, string("sar"))
  AddSymbol(string("<<="), TYPE_POSTOP + 2, fProcessBinaryEqOp, string("shl"))
  AddSymbol(string(">>="), TYPE_POSTOP + 2, fProcessBinaryEqOp, string("shr"))
  AddSymbol(string("->="), TYPE_POSTOP + 2, fProcessBinaryEqOp, string("ror"))
  AddSymbol(string("<-="), TYPE_POSTOP + 2, fProcessBinaryEqOp, string("rol"))
  AddSymbol(string("><="), TYPE_POSTOP + 2, fProcessBinaryEqOp, string("rev"))
  AddSymbol(string("&="), TYPE_POSTOP + 3, fProcessBinaryEqOp, string("and"))
  AddSymbol(string("|="), TYPE_POSTOP + 4, fProcessBinaryEqOp, string("or"))
  AddSymbol(string("^="), TYPE_POSTOP + 4, fProcessBinaryEqOp, string("xor"))
  AddSymbol(string("and="), TYPE_POSTOP + 10, fProcessBinaryEqOp, string("andl"))
  AddSymbol(string("or="), TYPE_POSTOP + 11, fProcessBinaryEqOp, string("orl"))
  AddSymbol(string("==="), TYPE_POSTOP + 8, fProcessBinaryEqOp, string("cmpeq"))
  AddSymbol(string("<>="), TYPE_POSTOP + 8, fProcessBinaryEqOp, string("cmpne"))
  AddSymbol(string("<="), TYPE_POSTOP + 8, fProcessBinaryEqOp, string("cmplt"))
  AddSymbol(string(">="), TYPE_POSTOP + 8, fProcessBinaryEqOp, string("cmpgt"))
  AddSymbol(string("=<="), TYPE_POSTOP + 8, fProcessBinaryEqOp, string("cmple"))
  AddSymbol(string("=>="), TYPE_POSTOP + 8, fProcessBinaryEqOp, string("cmpge"))
  AddSymbol(string(":="), TYPE_OP + 12, fProcessOp, 0)
  ' Unary Operators
  AddSymbol(string("^^"), TYPE_OP + 1, fProcessUnaryOp, string("sqrt"))
  AddSymbol(string("||"), TYPE_OP + 1, fProcessUnaryOp, string("abs"))
  AddSymbol(string("|<"), TYPE_OP + 1, fProcessUnaryOp, string("encode"))
  AddSymbol(string(">|"), TYPE_OP + 1, fProcessUnaryOp, string("decode"))
  AddSymbol(string("not"), TYPE_OP + 9, fProcessUnaryOp, string("notl"))
  AddSymbol(string("!"), TYPE_OP + 1, fProcessUnaryOp, string("comp"))
  AddSymbol(string("@"), TYPE_OP + 0, fProcessAt, 0)
  ' Extra Operators
  AddSymbol(string("++"), TYPE_POSTOP + 1, fProcessExtraOp, string("preinc-postinc"))
  AddSymbol(string("--"), TYPE_POSTOP + 1, fProcessExtraOp, string("predec-postdec"))
  AddSymbol(string("~"), TYPE_POSTOP + 1, fProcessExtraOp, string("sexb-postclr"))
  AddSymbol(string("~~"), TYPE_POSTOP + 1, fProcessExtraOp, string("sexw-postset"))
  AddSymbol(string("?"), TYPE_POSTOP + 1, fProcessExtraOp, string("randf-randr"))
  ' Seperators
  AddSymbol(string("("), 0, fProcessLeftParen, 0)
  AddSymbol(string(")"), 0, fProcessRightBracket, 0)
  AddSymbol(string("]"), 0, fProcessRightBracket, 0)
  AddSymbol(string(","), 0, fProcessRightBracket, 0)
  AddSymbol(string(":"), 0, fProcessRightBracket, 0)
  ' Intrinsic functions
  AddSymbol(string("string"), TYPE_PUB, fProcessPub, 0)
  AddSymbol(string("strsize"), TYPE_PUB, fProcessIntrinsic, 0)
  AddSymbol(string("strcomp"), TYPE_PUB, fProcessIntrinsic, 0)
  AddSymbol(string("bytemove"), TYPE_PUB, fProcessIntrinsic, 0)
  AddSymbol(string("wordmove"), TYPE_PUB, fProcessIntrinsic, 0)
  AddSymbol(string("longmove"), TYPE_PUB, fProcessIntrinsic, 0)
  AddSymbol(string("bytefill"), TYPE_PUB, fProcessIntrinsic, 0)
  AddSymbol(string("wordfill"), TYPE_PUB, fProcessIntrinsic, 0)
  AddSymbol(string("longfill"), TYPE_PUB, fProcessIntrinsic, 0)
  AddSymbol(string("cogid"), TYPE_PUB, fProcessIntrinsic, 0)
  AddSymbol(string("cognew"), TYPE_PUB, fProcessIntrinsic, 0)
  AddSymbol(string("coginit"), TYPE_PUB, fProcessIntrinsic, 0)
  AddSymbol(string("cogstop"), TYPE_PUB, fProcessIntrinsic, 0)
  AddSymbol(string("reboot"), TYPE_PUB, fProcessIntrinsic, 0)
  AddSymbol(string("locknew"), TYPE_PUB, fProcessIntrinsic, 0)
  AddSymbol(string("lockret"), TYPE_PUB, fProcessIntrinsic, 0)
  AddSymbol(string("lockclr"), TYPE_PUB, fProcessIntrinsic, 0)
  AddSymbol(string("lockset"), TYPE_PUB, fProcessIntrinsic, 0)
  AddSymbol(string("waitcnt"), TYPE_PUB, fProcessIntrinsic, 0)
  AddSymbol(string("waitpeq"), TYPE_PUB, fProcessIntrinsic, 0)
  AddSymbol(string("waitpne"), TYPE_PUB, fProcessIntrinsic, 0)
  AddSymbol(string("waitvid"), TYPE_PUB, fProcessIntrinsic, 0)
  ' Registers
  AddSymbol(string("par"), TYPE_REG, fProcessValue, $1f0)
  AddSymbol(string("cnt"), TYPE_REG, fProcessValue, $1f1)
  AddSymbol(string("ina"), TYPE_REG, fProcessValue, $1f2)
  AddSymbol(string("inb"), TYPE_REG, fProcessValue, $1f3)
  AddSymbol(string("outa"), TYPE_REG, fProcessValue, $1f4)
  AddSymbol(string("outb"), TYPE_REG, fProcessValue, $1f5)
  AddSymbol(string("dira"), TYPE_REG, fProcessValue, $1f6)
  AddSymbol(string("dirb"), TYPE_REG, fProcessValue, $1f7)
  AddSymbol(string("ctra"), TYPE_REG, fProcessValue, $1f8)
  AddSymbol(string("ctrb"), TYPE_REG, fProcessValue, $1f9)
  AddSymbol(string("frqa"), TYPE_REG, fProcessValue, $1fa)
  AddSymbol(string("frqb"), TYPE_REG, fProcessValue, $1fb)
  AddSymbol(string("phsa"), TYPE_REG, fProcessValue, $1fc)
  AddSymbol(string("phsb"), TYPE_REG, fProcessValue, $1fd)
  AddSymbol(string("vcfg"), TYPE_REG, fProcessValue, $1fe)
  AddSymbol(string("vscl"), TYPE_REG, fProcessValue, $1ff)
  ' Constants
  AddSymbol(string("false"), TYPE_CON, fProcessValue, 0)
  AddSymbol(string("true"), TYPE_CON, fProcessValue, $ffffffff)
  AddSymbol(string("negx"), TYPE_CON, fProcessValue, $80000000)
  AddSymbol(string("posx"), TYPE_CON, fProcessValue, $7fffffff)
  AddSymbol(string("pi"), TYPE_CON, fProcessValue, $40490fdb)
  AddSymbol(string("rcfast"), TYPE_CON, fProcessValue, $001)
  AddSymbol(string("rcslow"), TYPE_CON, fProcessValue, $002)
  AddSymbol(string("xinput"), TYPE_CON, fProcessValue, $004)
  AddSymbol(string("xtal1"), TYPE_CON, fProcessValue, $008)
  AddSymbol(string("xtal2"), TYPE_CON, fProcessValue, $010)
  AddSymbol(string("xtal3"), TYPE_CON, fProcessValue, $020)
  AddSymbol(string("pll1x"), TYPE_CON, fProcessValue, $040)
  AddSymbol(string("pll2x"), TYPE_CON, fProcessValue, $080)
  AddSymbol(string("pll4x"), TYPE_CON, fProcessValue, $100)
  AddSymbol(string("pll8x"), TYPE_CON, fProcessValue, $200)
  AddSymbol(string("pll16x"), TYPE_CON, fProcessValue, $400)

  DumpSymbols

PUB DumpSymbols | i, ptr
  ptr := @symtable
  repeat i from 0 to symnum - 1
    c.printf3(string("%3d %2d %s "), word[ptr][1], word[ptr][2], word[ptr])
    if word[ptr][1] => 256
      c.printf1(string("%s\n"), word[ptr][3])
    else
      c.printf1(string("%d\n"), word[ptr][3])
    ptr += 10
}
PUB AddKeywords | i, j, k, ptr
  c.printf0(string("Adding Spin keywords to the symbol table\n"))
  infile := c.fopen(string("spinsymb.txt"), string("r"))
  ifnot infile
    c.printf0(string("Could not open spinsymb.txt\n"))
    ErrorExit
  repeat while c.fgets(@buffer, 100, infile)
    strsub.RemoveCRLF(@buffer)
    tokens_0 := ptr := @buffer
    repeat i from 1 to 3
      ptr := strsub.FindChar(ptr, " ")
      byte[ptr++] := 0
      tokens_0[i] := ptr
    i := atol10(tokens_0[0])
    j := atol10(tokens_0[1])
    if byte[tokens_0[2]] == "0"
      tokens_0[2] := @nullstr
    if c.isdigit(byte[tokens_0[3]])
      k := atol10(tokens_0[3])
    else
      k := StrAlloc(strsize(tokens_0[3]) + 1)
      if (symnum => MAX_SYMBOLS)
        c.printf0(string("Symbol table is full\n"))
        ErrorExit
      c.strcpy(k, tokens_0[3])
    AddSymbol(tokens_0[2], i, j, k)
  c.fclose(infile)

PUB atol10(ptr)
  repeat while byte[ptr]
    result := (result * 10) + byte[ptr++] - "0"

' *********************************************************************
' This routine handles lines that use the { or {{ comment delimeter.
' Currently, the entire line is treated as a comment.
' *********************************************************************

PUB CommentLine(str) | retval
  retval := commentflag
  if (commentflag == 1) ' Search for a '}' character
  str := strsub.FindChar(str, "}")
  if (byte[str] == "}")
    commentflag := 0
  elseif (commentflag == 2) ' Search for a "}}" string
  str := strsub.FindStr(str, string("}}"))
  if (byte[str][0] == "}")
    commentflag := 0
  else ' Check first nonblank character for a '{'
  str := strsub.SkipChars(str, string(" \t"))
  if (byte[str][0] == "{")
    if (byte[str][1] == "{")
      commentflag := 2
    else
      commentflag := 1
  retval := commentflag
  return retval
' *********************************************************************
' This routine executes the first pass through the input
' file.  It extracts the global methods, variables and
' constants and adds them to the symbol table.  Every
' symbol that is used by the Spin prgram should be in
' the symbol table after this pass, except for the local
' variables, which are added at the beginning of each
' method.
' *********************************************************************

PUB GetGlobalSymbols | num, mode
  mode := TYPE_CON
  commentflag := 0
  linenum := 0
  c.printf0(string("Pass 1: Compiling Global Symbols\n"))
  repeat while (c.fgets(@buffer, 100, infile))
    linenum++
    strsub.RemoveCRLF(@buffer)
    'c.printf1(string("1: %s\n"), @buffer)
    if (CommentLine(@buffer))
      next
    num := strsub.GetTokens(@buffer, @buf2, @tokens_0)
    if (num == 0)
      next
    if (byte[tokens_0[0]][0] == SINGLE_QUOTE)
      next
    if (strsub.StrCompNoCase(tokens_0[0], string("pub")))
      mode := TYPE_PUB
      AddSymbolCheck(tokens_0[1], mode, fProcessPub, 0)
    elseif (strsub.StrCompNoCase(tokens_0[0], string("con")))
      mode := TYPE_CON
    elseif (strsub.StrCompNoCase(tokens_0[0], string("dat")))
      mode := TYPE_DAT
    elseif (strsub.StrCompNoCase(tokens_0[0], string("var")))
      mode := TYPE_VAR
    elseif (strsub.StrCompNoCase(tokens_0[0], string("obj")))
      mode := TYPE_OBJECT
    elseif (mode == TYPE_CON)
      if (num => 3 and c.strcmp(tokens_0[1], string("=")) == 0)
        AddSymbolCheck(tokens_0[0], mode, fProcessValue, 0)
    elseif (mode == TYPE_DAT)
      if (not strsub.StrCompNoCase(tokens_0[0], string("byte")) and not strsub.StrCompNoCase(tokens_0[0], string("word")) and not strsub.StrCompNoCase(tokens_0[0], string("long")))
        AddSymbolCheck(tokens_0[0], mode, fProcessValue, 0)
        if (num > 1)
          if (strsub.StrCompNoCase(tokens_0[1], string("byte")))
            word[@symtable +(10 *(symnum - 1)) + size] := 1
          elseif (strsub.StrCompNoCase(tokens_0[1], string("word")))
            word[@symtable +(10 *(symnum - 1)) + size] := 2
    elseif (mode == TYPE_VAR)
      if (num => 2 and(strsub.StrCompNoCase(tokens_0[0], string("byte")) or strsub.StrCompNoCase(tokens_0[0], string("word")) or strsub.StrCompNoCase(tokens_0[0], string("long"))))
        AddSymbolCheck(tokens_0[1], mode, fProcessValue, 0)
      if (strsub.StrCompNoCase(tokens_0[0], string("byte")))
        word[@symtable +(10 *(symnum - 1)) + size] := 1
      elseif (strsub.StrCompNoCase(tokens_0[0], string("word")))
        word[@symtable +(10 *(symnum - 1)) + size] := 2
    elseif (mode == TYPE_OBJECT)
      ProcessObject(num, @tokens_0)
  ' Save the index for the start of the local symbols
  symnum_save := symnum
' *********************************************************************
' This routine processes the PUB statement.  It sets the level
' to zero and initializes the level variables.  It also adds
' the local variables to the symbol table.
' *********************************************************************

PUB ProcessPubStatement(i, num, tokens) | ptr, skipflag
  skipflag := 0
  symnum := symnum_save
  ' Initialize level zero
  level := 0
  indent[level] := 0
  labelstart[level] := 0
  labelend[level] := 0
  looplevel[level] := 0
  looptype[level] := LOOP_PUB
  ' Add the local variables to the symbol table

  repeat while (i < num)
    ptr := strsub.FindChar(string("(),|:"), byte[long[tokens][i]][0])
    if (byte[ptr])
      i++
      next
    if (skipflag)
      if (byte[long[tokens][i]][0] == "]")
        skipflag := 0
    elseif (byte[long[tokens][i]][0] == "[")
      skipflag := 1
    else
      AddSymbolCheck(long[tokens][i], TYPE_LOCAL, fProcessValue, 0)
    i++
  return i
' *********************************************************************
' This routine should never be called
' *********************************************************************

PUB CatchObject(i, num, tokens, state)
  return i + 1
' *********************************************************************
' This routine is used during the first passed to extract
' the constants and public methods from an external object
' and add them to the symbol table.
' *********************************************************************

PUB ProcessObject(num, tokens) | len, objnum, objfile, objname[5], mode
  mode := TYPE_CON
  if (num < 1 or byte[long[tokens][0]][0] == SINGLE_QUOTE)
    return
  if (num <> 3 or c.strcmp(long[tokens][1], string(":")))
    c.printf0(string("Error in object line\n"))
    ErrorExit
  'printf("ProcessObject: AddSymbol %s\n", tokens[0]);
  objnum := AddSymbolCheck(long[tokens][0], TYPE_OBJECT, fCatchObject, 0)
  c.strcpy(@objname, long[tokens][2] + 1)
  len := strsize(@objname)
  if (len => 1)
    byte[@objname][len - 1] := 0
  c.strcat(@objname, string(".spn"))
  'printf("ProcessObject %s %s %s\n", tokens[0], tokens[1], tokens[2]);
  objfile := c.fopen(@objname, string("r"))
  if (not objfile)
    c.printf1(string("Could not open object file %s\n"), long[tokens][2])
    ErrorExit
  repeat while (c.fgets(@buffer, 1000, objfile))
    strsub.RemoveCRLF(@buffer)
    num := strsub.GetTokens(@buffer, @buf2, tokens)
    if (strsub.StrCompNoCase(long[tokens][0], string("pub")))
      mode := TYPE_PUB
      if (num => 2)
        c.strcpy(@objname, word[@symtable +(10 * objnum) + name])
        c.strcat(@objname, string("."))
        c.strcat(@objname, long[tokens][1])
        'printf("ProcessObject: AddSymbol %s\n", objname);
        AddSymbolCheck(@objname, mode, fProcessCallObj, 0)
    elseif (strsub.StrCompNoCase(long[tokens][0], string("pri")))
      mode := TYPE_PUB
    elseif (strsub.StrCompNoCase(long[tokens][0], string("obj")))
      mode := TYPE_OBJECT
    elseif (strsub.StrCompNoCase(long[tokens][0], string("dat")))
      mode := TYPE_DAT
    elseif (strsub.StrCompNoCase(long[tokens][0], string("var")))
      mode := TYPE_VAR
    elseif (strsub.StrCompNoCase(long[tokens][0], string("con")))
      mode := TYPE_CON
    elseif (mode == TYPE_CON)
      if (num => 2 and c.strcmp(long[tokens][1], string("=")) == 0)
        c.strcpy(@objname, word[@symtable +(10 * objnum) + name])
        c.strcat(@objname, string("#"))
        c.strcat(@objname, long[tokens][0])
        'printf("ProcessObject: AddSymbol %s\n", objname);
        AddSymbolCheck(@objname, mode, fProcessValue, 0)
  c.fclose(objfile)
' *********************************************************************
' This routine handles the left parenthesis by calling
' ProcessExpression with the highest operator precedence
' and an action of "load".  ProcessExpression must return
' pointing at a right parenthesis.
' *********************************************************************

PUB ProcessLeftParen(i, num, tokens, state)
  i := ProcessExpression(i + 1, num, tokens, 12, ACTION_LOAD)
  if (c.strcmp(long[tokens][i], string(")")))
    c.printf1(string("Expected ')' - %s\n"), long[tokens][i])
    ErrorExit
  return i + 1
' *********************************************************************
' This routine processes an expression by first processing a value,
' and then processing operators in a loop.  The operator functions
' will recursively call this routine to execute higher precedent
' operations.  The loop terminates when we hit the end of the line,
' a right parenthesis or bracket, a comma, or an operator with greater
' or equal precedence.
' *********************************************************************

PUB ProcessExpression(i, num, tokens, prec, action)
  i := ExecuteSymbol(i, num, tokens, EXPECT_VAL, prec, action)
  repeat while i < num
    ifnot prec > GetSymbolPrecedence(long[tokens][i])
      quit
    ifnot byte[long[tokens][i]][0] <> ":"
      quit
    ifnot byte[long[tokens][i]][0] <> ")"
      quit
    ifnot byte[long[tokens][i]][0] <> "]"
      quit
    ifnot byte[long[tokens][i]][0] <> ","
      quit
    i := ExecuteSymbol(i, num, tokens, EXPECT_OP, prec, ACTION_LOAD)
  return i
' *********************************************************************
' This routine process a case item statement
' *********************************************************************

PUB ProcessCaseItem(i, num, tokens) | j
  ' Process items to the left of the colon
  repeat while (i < num)
    i := ProcessExpression(i, num, tokens, 12, ACTION_LOAD)
    if (i < num)
      if (byte[long[tokens][i]][0] == ",")
        i++
      else
        quit
  ' Loop must have exited at a colon
  if (i => num or byte[long[tokens][i]][0] <> ":")
    c.printf0(string("Expected a colon, but encountered EOL\n"))
    ErrorExit
  i++
  ' Increment the level
  labelstart[++level] := 0
  labelend[level] := labelnum
  labelstart[level] := 0
  indent[level] := indent2
  looplevel[level] := looplevel[level - 1]
  looptype[level] := 0
  ' Process inline statement
  if (i < num)
    j := LocateAssignment(num, tokens)
    if (j < num)
      ProcessStore(0, num, tokens, j)
    else
      ProcessNonStore(0, num, tokens)
  return i
' *********************************************************************
' This routine process a statement that contains an assignment
' operator.
' *********************************************************************

PUB ProcessStore(i, num, tokens, assignpos) | j, l, state
  if (assignpos + 1 => num)
    c.printf0(string("Expected value, found EOL\n"))
    ErrorExit
  ' Process the right side of the statement
  l := ProcessExpression(assignpos + 1, num, tokens, 12, ACTION_LOAD)
  ' Process the left side
  i := ExecuteSymbol(i, num, tokens, EXPECT_VAL, 12, ACTION_STORE)
  if (i <> assignpos)
    c.printf1(string("Expected assignment op, found %s\n"), long[tokens][i])
    ErrorExit
  return l
' *********************************************************************
' This routine processes a statement that does not contain an
' assignment operator.
' *********************************************************************

PUB ProcessNonStore(i, num, tokens)
  i := ProcessExpression(i, num, tokens, 12, ACTION_NONE)
  if (i < num)
    c.printf1(string("Expected EOL, found %s\n"), long[tokens][i])
    ErrorExit
  return i
' *********************************************************************
' This routine determines the indention of a line.
' *********************************************************************

PUB GetIndent(str)
  indent2 := 0
  repeat while (byte[str])
    if (byte[str] == " ")
      indent2++
    elseif (byte[str] == TAB_CHAR)
      indent2 :=(indent2 + 8) & ! 7
    else
      quit
    str++
' *********************************************************************
' This routine drops down to lower levels until the block
' indention is less than the current statement's indention.
' It prints the labels and jmps for each level depding on
' the label values that were set.  The ELSEIF block must be
' handled differently.
' *********************************************************************

PUB DropLevels(indent1)
  repeat while (level => 0 and indent[level] => indent1)
    if (looptype[level] == LOOP_ELSEIF)
      c.fprintf1(outfile, string("label%4.4d\n"), labelend[level])
      c.fprintf1(outfile, string("label%4.4d\n"), labelstart[level])
    elseif (looptype[level] == LOOP_CASE)
      c.fprintf1(outfile, string("label%4.4d\n"), labelend[level])
      c.fprintf0(outfile, string("        casedone\n"))
    else
      if (labelstart[level])
        c.fprintf1(outfile, string("        jmp label%4.4d\n"), labelstart[level])
      if (labelend[level])
        c.fprintf1(outfile, string("label%4.4d\n"), labelend[level])
    level--
' *********************************************************************
' This routine handles the end of method by dropping to
' level zero and printing a return at the end.
' *********************************************************************

PUB PrintEndOfPub
  DropLevels(- 1)
  c.fprintf0(outfile, string("        ret\n\n"))
' *********************************************************************
' This routine searches for an assignment operator, and
' returns it's token index if found.
' *********************************************************************

PUB LocateAssignment(num, tokens) | i, len
  i := 0
  repeat while (i < num)
    len := strsize(long[tokens][i])
    'printf("%d, %d, %s\n", i, len, tokens[i]);
    if (len > 0 and byte[long[tokens][i]][len - 1] == "=" and c.strcmp(long[tokens][i], string("==")))
      quit
    i++
  'if (i < num) printf("Found %s\n", tokens[i]);
  return i
' *********************************************************************
' This routine performs the second pass through the input file.
' It converts the statements within the Spin methods to Spasm code.
' *********************************************************************

PUB GenerateSpasm | index, i, j, num, sectiontype
  c.printf0(string("Pass 2: Generating Spasm Code\n"))
  sectiontype := 3
  commentflag := 0
  linenum := 0
  repeat while (c.fgets(@buffer, 1000, infile))
    linenum++
    strsub.RemoveCRLF(@buffer)
    if (CommentLine(@buffer))
      c.fprintf1(outfile, string("%s\n"), @buffer)
      next
    num := strsub.GetTokens(@buffer, @buf2, @tokens_0)
    if (num == 0)
      if (sectiontype <> 0 and sectiontype <> 1)
        c.fprintf0(outfile, string("\n"))
      next
    elseif (byte[tokens_0[0]][0] == SINGLE_QUOTE)
      c.fprintf1(outfile, string("%s\n"), @buffer)
      next
    GetIndent(@buffer)
    ' Search for a start of a Spin section
    index := strsub.FindListNoCase(tokens_0[0], @section_keyword)
    if (sectiontype < 2) ' Check if in a current pub
      if (index => 0)
        PrintEndOfPub
        sectiontype := index
        c.fprintf1(outfile, string("%s\n"), @buffer)
        if (index < 2) ' pub or pri
          ProcessPubStatement(2, num, @tokens_0)
      else
        if (strsub.FindListNoCase(tokens_0[0], @elselist) => 0)
          DropLevels(indent2 + 1)
        else
          DropLevels(indent2)
        c.fprintf1(outfile, string("\n'%s\n"), @buffer)
        if (looptype[level] == LOOP_CASE and indent2 > indent[level])
          ProcessCaseItem(0, num, @tokens_0)
        else
          j := LocateAssignment(num, @tokens_0)
          if (j < num)
            ProcessStore(0, num, @tokens_0, j)
          else
            ProcessNonStore(0, num, @tokens_0)
    else ' Otherwise, just print the line and check for a pub
      i := 0
      ' Ensure that labels start in the first colunm in a DAT section
      if (sectiontype == 2 and strsub.FindListNoCase(tokens_0[0], @type_keyword) < 0)
        repeat while (buffer[i] == " " or buffer[i] == TAB_CHAR)
          i++
      c.fprintf1(outfile, string("%s\n"), @buffer[i])
      if (index => 0)
        ' Check if pub or pri statement
        if (index < 2)
          ProcessPubStatement(2, num, @tokens_0)
        sectiontype := index
  ' Print the end of the pub
  if (sectiontype < 2)
    PrintEndOfPub
