CON
  _clkmode = 0
  _xinfreq = $4E495053 ' SPIN

  proc_type_pasm_driver = sys#proc_type_pasm | sys#proc_type_driver

OBJ
  c : "clib_os"
  sys : "sysdefs"
  vga : "vgatextp"

PUB main(argc, argv) | num, handle
  if argc == 2 and strcomp(long[argv][1], string("-r"))
    ifnot (num := long[sys#vga_cog])
      c.printf0(string("VGA driver is not loaded\n"))
      return
    c.kill(num - 1)
    long[sys#vga_cog] := 0
    c.printf0(string("VGA driver removed\n"))
    return
  elseif argc == 1
    if long[sys#vga_cog]
      c.printf0(string("VGA driver is already loaded\n"))
      return
    handle := c.malloc(vga#handlesize)
    ifnot handle
      c.printf0(string("Could not allocate the VGA data structure\n"))
      c.exit(1)
    long[sys#vga_handle] := handle
    num := vga.start(handle, 16)
    ifnot num
      c.printf0(string("Could not load VGA driver\n"))
    else
      long[sys#vga_cog] := num
      AddToCogTable(num-1, proc_type_pasm_driver, string("VGA Driver"), handle, vga#handlesize)
      c.printf0(string("VGA driver loaded\n"))
  else
    c.printf0(string("usage: loadvga [-r]\n"))
    c.printf0(string("    Loads the VGA driver, unles the -r option is specified,\n"))
    c.printf0(string("    in which case the driver will be removed.\n"))

PUB AddToCogTable(cognum, type, name, startaddr, size) | entryptr
  entryptr := sys#cogtable + (cognum * 24)
  byte[entryptr] := type
  bytemove(entryptr+1, name, 19)
  byte[entryptr+19] := 0
  word[entryptr+20] := startaddr
  word[entryptr+22] := size

